#!/bin/bash

ezxhome=/ezxlocal/home
rwetc=/ezxlocal/rwetc

myfile=`basename $0`
mypath=`echo $0 | sed -e "s|$myfile||g" | sed -e "s|/$||g"`
export PATH=$PATH:$mypath

# create rwetc directory
if [ ! -d $rwetc ]
then
  cp -dprf /etc $rwetc
  cat $rwetc/passwd | sed -e "s|/root|$ezxhome/root|g" -e "s|/home/native|$ezxhome/ezx|g" > /tmp/passwd
  cp /tmp/passwd $rwetc
  rm /tmp/passwd
fi
# mount rwetc instead of real /etc one
[ -z `mount | grep $rwetc` ] && mount -o bind $rwetc /etc

# generate host key
if [ ! -d /etc/dropbear ] 
then
  mkdir -p /etc/dropbear
  $mypath/dropbearkey -t rsa -f /etc/dropbear/dropbear_rsa_host_key
  $mypath/dropbearkey -t dss -f /etc/dropbear/dropbear_dss_host_key
fi

# create new home directories for ezx and root users
[ ! -d $ezxhome ] && mkdir -p $ezxhome
for user in ezx root
do
  [ ! -d $ezxhome/$user ] && mkdir -p $ezxhome/$user
  if [ ! -f $ezxhome/$user/.bashrc ]
  then
    (
      echo "PS1='\u@\h:\w\$ '";
      echo "eval \"\`dircolors -b\`\"";
      echo "alias ls='ls --color=auto'";
      echo "export HOME=$ezxhome/$user";
      echo ". /etc/default/rcS";
      echo ". /etc/init.d/ezxenvr.sh";
    ) > $ezxhome/$user/.bashrc
  fi
# generate user key
  if [ ! -d $ezxhome/$user/.ssh ]
  then
    mkdir -p $ezxhome/$user/.ssh
    $mypath/dropbearkey -t rsa -f $ezxhome/$user/.ssh/id_rsa.db
  fi
# fix any permission and ownership issue
  chmod -R go-rwX $ezxhome/$user/.ssh
  chown -R $user:$user $ezxhome/$user
done
