#!/bin/bash
# Bragon, 2006/10/6
# Modified by Bragon, 2006/6/23, 2007/04/04

DAEMON=dropbear
DAEMONPIDF=/var/run/dropbear.pid
DAEMONOPTS="-d /etc/dropbear/dropbear_dss_host_key -r /etc/dropbear/dropbear_rsa_host_key -P $DAEMONPIDF"
# note DAEMONPIDS can also contain spawn processes from initiated connections by clients
DAEMONPIDS=`pidof $DAEMON`

myfile=`basename $0`
mypath=`echo $0 | sed -e "s|$myfile||g" | sed -e "s|/$||g"`
cd "$mypath"
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:"$mypath"
export QTDIR=/usr/lib/ezx

# make sure we are in usbnet mode
start-stop-daemon --start --quiet --chuid root --exec "$mypath"/usbnet.sh
# perform setup and replace existing /etc by writable dir
start-stop-daemon --start --quiet --chuid root --exec "$mypath"/setup.sh

# remove previously stalled daemon pid file if no daemon process exist
[ -f $DAEMONPIDF -a -z "$DAEMONPIDS" ] && start-stop-daemon --start --quiet --chuid root --exec /bin/rm -- -f $DAEMONPIDF

# check if pid in DAEMONPIDF is an active process
if [ -f $DAEMONPIDF ];
then
  daemonpid=`cat $DAEMONPIDF`
  daemonactive=`/bin/ps h $daemonpid | grep $DAEMON`
else
  daemonactive=
fi

if [ -n "$daemonactive" ];
then
# stop service if daemon is active
# pid DAEMONPIDF is correct: stop it the usual way
  if start-stop-daemon --stop --quiet --chuid root --oknodo --pidfile $DAEMONPIDF
  then
    "$mypath"/ezxpopup.sh "$DAEMON service stopped" ok
  else
    "$mypath"/ezxpopup.sh "$DAEMON service stop failed: forcing kill" ok
# note: this is not clean since it kills also all the client initiated connections...
    start-stop-daemon --stop --quiet --chuid root --oknodo --name $DAEMON
  fi
# remove potentially stalled PID file
  [ -f $DAEMONPIDF ] && start-stop-daemon --start --quiet --chuid root --exec /bin/rm -- -f $DAEMONPIDF
else
# start service
# note: the option --make-pid is a bad idea since the pid file is created before execution of the daemon...
  if start-stop-daemon --start --quiet --chuid root --pidfile $DAEMONPIDF --exec "$mypath"/$DAEMON -- $DAEMONOPTS
  then 
    "$mypath"/ezxpopup.sh "$DAEMON service started" ok
# if the daemon pid file is not created create it anyway with current pids of running processes: issue with multiple instanciations of the process
    [ ! -f $DAEMONPIDF ] && start-stop-daemon --start --quiet --chuid root --exec "$mypath"/logpid.sh -- $DAEMON $DAEMONPIDF
  else
    "$mypath"/ezxpopup.sh "$DAEMON service start failed" no
  fi
fi
